// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"gochassis/ent/chat"
	"gochassis/ent/chatroom"
	"gochassis/ent/predicate"
	"gochassis/ent/profile"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// ChatUpdate is the builder for updating Chat entities.
type ChatUpdate struct {
	config
	hooks    []Hook
	mutation *ChatMutation
}

// Where appends a list predicates to the ChatUpdate builder.
func (cu *ChatUpdate) Where(ps ...predicate.Chat) *ChatUpdate {
	cu.mutation.Where(ps...)
	return cu
}

// SetText sets the "text" field.
func (cu *ChatUpdate) SetText(s string) *ChatUpdate {
	cu.mutation.SetText(s)
	return cu
}

// SetAttachment sets the "attachment" field.
func (cu *ChatUpdate) SetAttachment(s string) *ChatUpdate {
	cu.mutation.SetAttachment(s)
	return cu
}

// SetNillableAttachment sets the "attachment" field if the given value is not nil.
func (cu *ChatUpdate) SetNillableAttachment(s *string) *ChatUpdate {
	if s != nil {
		cu.SetAttachment(*s)
	}
	return cu
}

// ClearAttachment clears the value of the "attachment" field.
func (cu *ChatUpdate) ClearAttachment() *ChatUpdate {
	cu.mutation.ClearAttachment()
	return cu
}

// SetAttachmentType sets the "attachment_type" field.
func (cu *ChatUpdate) SetAttachmentType(s string) *ChatUpdate {
	cu.mutation.SetAttachmentType(s)
	return cu
}

// SetNillableAttachmentType sets the "attachment_type" field if the given value is not nil.
func (cu *ChatUpdate) SetNillableAttachmentType(s *string) *ChatUpdate {
	if s != nil {
		cu.SetAttachmentType(*s)
	}
	return cu
}

// ClearAttachmentType clears the value of the "attachment_type" field.
func (cu *ChatUpdate) ClearAttachmentType() *ChatUpdate {
	cu.mutation.ClearAttachmentType()
	return cu
}

// SetFrontendUUID sets the "frontend_uuid" field.
func (cu *ChatUpdate) SetFrontendUUID(s string) *ChatUpdate {
	cu.mutation.SetFrontendUUID(s)
	return cu
}

// SetCreatedAt sets the "created_at" field.
func (cu *ChatUpdate) SetCreatedAt(t time.Time) *ChatUpdate {
	cu.mutation.SetCreatedAt(t)
	return cu
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (cu *ChatUpdate) SetNillableCreatedAt(t *time.Time) *ChatUpdate {
	if t != nil {
		cu.SetCreatedAt(*t)
	}
	return cu
}

// SetUpdatedAt sets the "updated_at" field.
func (cu *ChatUpdate) SetUpdatedAt(t time.Time) *ChatUpdate {
	cu.mutation.SetUpdatedAt(t)
	return cu
}

// SetDeletedAt sets the "deleted_at" field.
func (cu *ChatUpdate) SetDeletedAt(t time.Time) *ChatUpdate {
	cu.mutation.SetDeletedAt(t)
	return cu
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (cu *ChatUpdate) SetNillableDeletedAt(t *time.Time) *ChatUpdate {
	if t != nil {
		cu.SetDeletedAt(*t)
	}
	return cu
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (cu *ChatUpdate) ClearDeletedAt() *ChatUpdate {
	cu.mutation.ClearDeletedAt()
	return cu
}

// SetReplyTo sets the "reply_to" field.
func (cu *ChatUpdate) SetReplyTo(i int) *ChatUpdate {
	cu.mutation.SetReplyTo(i)
	return cu
}

// SetNillableReplyTo sets the "reply_to" field if the given value is not nil.
func (cu *ChatUpdate) SetNillableReplyTo(i *int) *ChatUpdate {
	if i != nil {
		cu.SetReplyTo(*i)
	}
	return cu
}

// ClearReplyTo clears the value of the "reply_to" field.
func (cu *ChatUpdate) ClearReplyTo() *ChatUpdate {
	cu.mutation.ClearReplyTo()
	return cu
}

// SetProfileID sets the "profile" edge to the Profile entity by ID.
func (cu *ChatUpdate) SetProfileID(id int) *ChatUpdate {
	cu.mutation.SetProfileID(id)
	return cu
}

// SetProfile sets the "profile" edge to the Profile entity.
func (cu *ChatUpdate) SetProfile(p *Profile) *ChatUpdate {
	return cu.SetProfileID(p.ID)
}

// SetChatRoomID sets the "chat_room" edge to the ChatRoom entity by ID.
func (cu *ChatUpdate) SetChatRoomID(id int) *ChatUpdate {
	cu.mutation.SetChatRoomID(id)
	return cu
}

// SetChatRoom sets the "chat_room" edge to the ChatRoom entity.
func (cu *ChatUpdate) SetChatRoom(c *ChatRoom) *ChatUpdate {
	return cu.SetChatRoomID(c.ID)
}

// SetReplyToEdgeID sets the "reply_to_edge" edge to the Chat entity by ID.
func (cu *ChatUpdate) SetReplyToEdgeID(id int) *ChatUpdate {
	cu.mutation.SetReplyToEdgeID(id)
	return cu
}

// SetNillableReplyToEdgeID sets the "reply_to_edge" edge to the Chat entity by ID if the given value is not nil.
func (cu *ChatUpdate) SetNillableReplyToEdgeID(id *int) *ChatUpdate {
	if id != nil {
		cu = cu.SetReplyToEdgeID(*id)
	}
	return cu
}

// SetReplyToEdge sets the "reply_to_edge" edge to the Chat entity.
func (cu *ChatUpdate) SetReplyToEdge(c *Chat) *ChatUpdate {
	return cu.SetReplyToEdgeID(c.ID)
}

// AddReplyIDs adds the "replies" edge to the Chat entity by IDs.
func (cu *ChatUpdate) AddReplyIDs(ids ...int) *ChatUpdate {
	cu.mutation.AddReplyIDs(ids...)
	return cu
}

// AddReplies adds the "replies" edges to the Chat entity.
func (cu *ChatUpdate) AddReplies(c ...*Chat) *ChatUpdate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return cu.AddReplyIDs(ids...)
}

// Mutation returns the ChatMutation object of the builder.
func (cu *ChatUpdate) Mutation() *ChatMutation {
	return cu.mutation
}

// ClearProfile clears the "profile" edge to the Profile entity.
func (cu *ChatUpdate) ClearProfile() *ChatUpdate {
	cu.mutation.ClearProfile()
	return cu
}

// ClearChatRoom clears the "chat_room" edge to the ChatRoom entity.
func (cu *ChatUpdate) ClearChatRoom() *ChatUpdate {
	cu.mutation.ClearChatRoom()
	return cu
}

// ClearReplyToEdge clears the "reply_to_edge" edge to the Chat entity.
func (cu *ChatUpdate) ClearReplyToEdge() *ChatUpdate {
	cu.mutation.ClearReplyToEdge()
	return cu
}

// ClearReplies clears all "replies" edges to the Chat entity.
func (cu *ChatUpdate) ClearReplies() *ChatUpdate {
	cu.mutation.ClearReplies()
	return cu
}

// RemoveReplyIDs removes the "replies" edge to Chat entities by IDs.
func (cu *ChatUpdate) RemoveReplyIDs(ids ...int) *ChatUpdate {
	cu.mutation.RemoveReplyIDs(ids...)
	return cu
}

// RemoveReplies removes "replies" edges to Chat entities.
func (cu *ChatUpdate) RemoveReplies(c ...*Chat) *ChatUpdate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return cu.RemoveReplyIDs(ids...)
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (cu *ChatUpdate) Save(ctx context.Context) (int, error) {
	cu.defaults()
	return withHooks[int, ChatMutation](ctx, cu.sqlSave, cu.mutation, cu.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (cu *ChatUpdate) SaveX(ctx context.Context) int {
	affected, err := cu.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (cu *ChatUpdate) Exec(ctx context.Context) error {
	_, err := cu.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (cu *ChatUpdate) ExecX(ctx context.Context) {
	if err := cu.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (cu *ChatUpdate) defaults() {
	if _, ok := cu.mutation.UpdatedAt(); !ok {
		v := chat.UpdateDefaultUpdatedAt()
		cu.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (cu *ChatUpdate) check() error {
	if v, ok := cu.mutation.Text(); ok {
		if err := chat.TextValidator(v); err != nil {
			return &ValidationError{Name: "text", err: fmt.Errorf(`ent: validator failed for field "Chat.text": %w`, err)}
		}
	}
	if _, ok := cu.mutation.ProfileID(); cu.mutation.ProfileCleared() && !ok {
		return errors.New(`ent: clearing a required unique edge "Chat.profile"`)
	}
	if _, ok := cu.mutation.ChatRoomID(); cu.mutation.ChatRoomCleared() && !ok {
		return errors.New(`ent: clearing a required unique edge "Chat.chat_room"`)
	}
	return nil
}

func (cu *ChatUpdate) sqlSave(ctx context.Context) (n int, err error) {
	if err := cu.check(); err != nil {
		return n, err
	}
	_spec := sqlgraph.NewUpdateSpec(chat.Table, chat.Columns, sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt))
	if ps := cu.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := cu.mutation.Text(); ok {
		_spec.SetField(chat.FieldText, field.TypeString, value)
	}
	if value, ok := cu.mutation.Attachment(); ok {
		_spec.SetField(chat.FieldAttachment, field.TypeString, value)
	}
	if cu.mutation.AttachmentCleared() {
		_spec.ClearField(chat.FieldAttachment, field.TypeString)
	}
	if value, ok := cu.mutation.AttachmentType(); ok {
		_spec.SetField(chat.FieldAttachmentType, field.TypeString, value)
	}
	if cu.mutation.AttachmentTypeCleared() {
		_spec.ClearField(chat.FieldAttachmentType, field.TypeString)
	}
	if value, ok := cu.mutation.FrontendUUID(); ok {
		_spec.SetField(chat.FieldFrontendUUID, field.TypeString, value)
	}
	if value, ok := cu.mutation.CreatedAt(); ok {
		_spec.SetField(chat.FieldCreatedAt, field.TypeTime, value)
	}
	if value, ok := cu.mutation.UpdatedAt(); ok {
		_spec.SetField(chat.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := cu.mutation.DeletedAt(); ok {
		_spec.SetField(chat.FieldDeletedAt, field.TypeTime, value)
	}
	if cu.mutation.DeletedAtCleared() {
		_spec.ClearField(chat.FieldDeletedAt, field.TypeTime)
	}
	if cu.mutation.ProfileCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ProfileTable,
			Columns: []string{chat.ProfileColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cu.mutation.ProfileIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ProfileTable,
			Columns: []string{chat.ProfileColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if cu.mutation.ChatRoomCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ChatRoomTable,
			Columns: []string{chat.ChatRoomColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cu.mutation.ChatRoomIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ChatRoomTable,
			Columns: []string{chat.ChatRoomColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if cu.mutation.ReplyToEdgeCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ReplyToEdgeTable,
			Columns: []string{chat.ReplyToEdgeColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cu.mutation.ReplyToEdgeIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ReplyToEdgeTable,
			Columns: []string{chat.ReplyToEdgeColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if cu.mutation.RepliesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chat.RepliesTable,
			Columns: []string{chat.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cu.mutation.RemovedRepliesIDs(); len(nodes) > 0 && !cu.mutation.RepliesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chat.RepliesTable,
			Columns: []string{chat.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cu.mutation.RepliesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chat.RepliesTable,
			Columns: []string{chat.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, cu.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{chat.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	cu.mutation.done = true
	return n, nil
}

// ChatUpdateOne is the builder for updating a single Chat entity.
type ChatUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *ChatMutation
}

// SetText sets the "text" field.
func (cuo *ChatUpdateOne) SetText(s string) *ChatUpdateOne {
	cuo.mutation.SetText(s)
	return cuo
}

// SetAttachment sets the "attachment" field.
func (cuo *ChatUpdateOne) SetAttachment(s string) *ChatUpdateOne {
	cuo.mutation.SetAttachment(s)
	return cuo
}

// SetNillableAttachment sets the "attachment" field if the given value is not nil.
func (cuo *ChatUpdateOne) SetNillableAttachment(s *string) *ChatUpdateOne {
	if s != nil {
		cuo.SetAttachment(*s)
	}
	return cuo
}

// ClearAttachment clears the value of the "attachment" field.
func (cuo *ChatUpdateOne) ClearAttachment() *ChatUpdateOne {
	cuo.mutation.ClearAttachment()
	return cuo
}

// SetAttachmentType sets the "attachment_type" field.
func (cuo *ChatUpdateOne) SetAttachmentType(s string) *ChatUpdateOne {
	cuo.mutation.SetAttachmentType(s)
	return cuo
}

// SetNillableAttachmentType sets the "attachment_type" field if the given value is not nil.
func (cuo *ChatUpdateOne) SetNillableAttachmentType(s *string) *ChatUpdateOne {
	if s != nil {
		cuo.SetAttachmentType(*s)
	}
	return cuo
}

// ClearAttachmentType clears the value of the "attachment_type" field.
func (cuo *ChatUpdateOne) ClearAttachmentType() *ChatUpdateOne {
	cuo.mutation.ClearAttachmentType()
	return cuo
}

// SetFrontendUUID sets the "frontend_uuid" field.
func (cuo *ChatUpdateOne) SetFrontendUUID(s string) *ChatUpdateOne {
	cuo.mutation.SetFrontendUUID(s)
	return cuo
}

// SetCreatedAt sets the "created_at" field.
func (cuo *ChatUpdateOne) SetCreatedAt(t time.Time) *ChatUpdateOne {
	cuo.mutation.SetCreatedAt(t)
	return cuo
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (cuo *ChatUpdateOne) SetNillableCreatedAt(t *time.Time) *ChatUpdateOne {
	if t != nil {
		cuo.SetCreatedAt(*t)
	}
	return cuo
}

// SetUpdatedAt sets the "updated_at" field.
func (cuo *ChatUpdateOne) SetUpdatedAt(t time.Time) *ChatUpdateOne {
	cuo.mutation.SetUpdatedAt(t)
	return cuo
}

// SetDeletedAt sets the "deleted_at" field.
func (cuo *ChatUpdateOne) SetDeletedAt(t time.Time) *ChatUpdateOne {
	cuo.mutation.SetDeletedAt(t)
	return cuo
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (cuo *ChatUpdateOne) SetNillableDeletedAt(t *time.Time) *ChatUpdateOne {
	if t != nil {
		cuo.SetDeletedAt(*t)
	}
	return cuo
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (cuo *ChatUpdateOne) ClearDeletedAt() *ChatUpdateOne {
	cuo.mutation.ClearDeletedAt()
	return cuo
}

// SetReplyTo sets the "reply_to" field.
func (cuo *ChatUpdateOne) SetReplyTo(i int) *ChatUpdateOne {
	cuo.mutation.SetReplyTo(i)
	return cuo
}

// SetNillableReplyTo sets the "reply_to" field if the given value is not nil.
func (cuo *ChatUpdateOne) SetNillableReplyTo(i *int) *ChatUpdateOne {
	if i != nil {
		cuo.SetReplyTo(*i)
	}
	return cuo
}

// ClearReplyTo clears the value of the "reply_to" field.
func (cuo *ChatUpdateOne) ClearReplyTo() *ChatUpdateOne {
	cuo.mutation.ClearReplyTo()
	return cuo
}

// SetProfileID sets the "profile" edge to the Profile entity by ID.
func (cuo *ChatUpdateOne) SetProfileID(id int) *ChatUpdateOne {
	cuo.mutation.SetProfileID(id)
	return cuo
}

// SetProfile sets the "profile" edge to the Profile entity.
func (cuo *ChatUpdateOne) SetProfile(p *Profile) *ChatUpdateOne {
	return cuo.SetProfileID(p.ID)
}

// SetChatRoomID sets the "chat_room" edge to the ChatRoom entity by ID.
func (cuo *ChatUpdateOne) SetChatRoomID(id int) *ChatUpdateOne {
	cuo.mutation.SetChatRoomID(id)
	return cuo
}

// SetChatRoom sets the "chat_room" edge to the ChatRoom entity.
func (cuo *ChatUpdateOne) SetChatRoom(c *ChatRoom) *ChatUpdateOne {
	return cuo.SetChatRoomID(c.ID)
}

// SetReplyToEdgeID sets the "reply_to_edge" edge to the Chat entity by ID.
func (cuo *ChatUpdateOne) SetReplyToEdgeID(id int) *ChatUpdateOne {
	cuo.mutation.SetReplyToEdgeID(id)
	return cuo
}

// SetNillableReplyToEdgeID sets the "reply_to_edge" edge to the Chat entity by ID if the given value is not nil.
func (cuo *ChatUpdateOne) SetNillableReplyToEdgeID(id *int) *ChatUpdateOne {
	if id != nil {
		cuo = cuo.SetReplyToEdgeID(*id)
	}
	return cuo
}

// SetReplyToEdge sets the "reply_to_edge" edge to the Chat entity.
func (cuo *ChatUpdateOne) SetReplyToEdge(c *Chat) *ChatUpdateOne {
	return cuo.SetReplyToEdgeID(c.ID)
}

// AddReplyIDs adds the "replies" edge to the Chat entity by IDs.
func (cuo *ChatUpdateOne) AddReplyIDs(ids ...int) *ChatUpdateOne {
	cuo.mutation.AddReplyIDs(ids...)
	return cuo
}

// AddReplies adds the "replies" edges to the Chat entity.
func (cuo *ChatUpdateOne) AddReplies(c ...*Chat) *ChatUpdateOne {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return cuo.AddReplyIDs(ids...)
}

// Mutation returns the ChatMutation object of the builder.
func (cuo *ChatUpdateOne) Mutation() *ChatMutation {
	return cuo.mutation
}

// ClearProfile clears the "profile" edge to the Profile entity.
func (cuo *ChatUpdateOne) ClearProfile() *ChatUpdateOne {
	cuo.mutation.ClearProfile()
	return cuo
}

// ClearChatRoom clears the "chat_room" edge to the ChatRoom entity.
func (cuo *ChatUpdateOne) ClearChatRoom() *ChatUpdateOne {
	cuo.mutation.ClearChatRoom()
	return cuo
}

// ClearReplyToEdge clears the "reply_to_edge" edge to the Chat entity.
func (cuo *ChatUpdateOne) ClearReplyToEdge() *ChatUpdateOne {
	cuo.mutation.ClearReplyToEdge()
	return cuo
}

// ClearReplies clears all "replies" edges to the Chat entity.
func (cuo *ChatUpdateOne) ClearReplies() *ChatUpdateOne {
	cuo.mutation.ClearReplies()
	return cuo
}

// RemoveReplyIDs removes the "replies" edge to Chat entities by IDs.
func (cuo *ChatUpdateOne) RemoveReplyIDs(ids ...int) *ChatUpdateOne {
	cuo.mutation.RemoveReplyIDs(ids...)
	return cuo
}

// RemoveReplies removes "replies" edges to Chat entities.
func (cuo *ChatUpdateOne) RemoveReplies(c ...*Chat) *ChatUpdateOne {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return cuo.RemoveReplyIDs(ids...)
}

// Where appends a list predicates to the ChatUpdate builder.
func (cuo *ChatUpdateOne) Where(ps ...predicate.Chat) *ChatUpdateOne {
	cuo.mutation.Where(ps...)
	return cuo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (cuo *ChatUpdateOne) Select(field string, fields ...string) *ChatUpdateOne {
	cuo.fields = append([]string{field}, fields...)
	return cuo
}

// Save executes the query and returns the updated Chat entity.
func (cuo *ChatUpdateOne) Save(ctx context.Context) (*Chat, error) {
	cuo.defaults()
	return withHooks[*Chat, ChatMutation](ctx, cuo.sqlSave, cuo.mutation, cuo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (cuo *ChatUpdateOne) SaveX(ctx context.Context) *Chat {
	node, err := cuo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (cuo *ChatUpdateOne) Exec(ctx context.Context) error {
	_, err := cuo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (cuo *ChatUpdateOne) ExecX(ctx context.Context) {
	if err := cuo.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (cuo *ChatUpdateOne) defaults() {
	if _, ok := cuo.mutation.UpdatedAt(); !ok {
		v := chat.UpdateDefaultUpdatedAt()
		cuo.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (cuo *ChatUpdateOne) check() error {
	if v, ok := cuo.mutation.Text(); ok {
		if err := chat.TextValidator(v); err != nil {
			return &ValidationError{Name: "text", err: fmt.Errorf(`ent: validator failed for field "Chat.text": %w`, err)}
		}
	}
	if _, ok := cuo.mutation.ProfileID(); cuo.mutation.ProfileCleared() && !ok {
		return errors.New(`ent: clearing a required unique edge "Chat.profile"`)
	}
	if _, ok := cuo.mutation.ChatRoomID(); cuo.mutation.ChatRoomCleared() && !ok {
		return errors.New(`ent: clearing a required unique edge "Chat.chat_room"`)
	}
	return nil
}

func (cuo *ChatUpdateOne) sqlSave(ctx context.Context) (_node *Chat, err error) {
	if err := cuo.check(); err != nil {
		return _node, err
	}
	_spec := sqlgraph.NewUpdateSpec(chat.Table, chat.Columns, sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt))
	id, ok := cuo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "Chat.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := cuo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, chat.FieldID)
		for _, f := range fields {
			if !chat.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != chat.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := cuo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := cuo.mutation.Text(); ok {
		_spec.SetField(chat.FieldText, field.TypeString, value)
	}
	if value, ok := cuo.mutation.Attachment(); ok {
		_spec.SetField(chat.FieldAttachment, field.TypeString, value)
	}
	if cuo.mutation.AttachmentCleared() {
		_spec.ClearField(chat.FieldAttachment, field.TypeString)
	}
	if value, ok := cuo.mutation.AttachmentType(); ok {
		_spec.SetField(chat.FieldAttachmentType, field.TypeString, value)
	}
	if cuo.mutation.AttachmentTypeCleared() {
		_spec.ClearField(chat.FieldAttachmentType, field.TypeString)
	}
	if value, ok := cuo.mutation.FrontendUUID(); ok {
		_spec.SetField(chat.FieldFrontendUUID, field.TypeString, value)
	}
	if value, ok := cuo.mutation.CreatedAt(); ok {
		_spec.SetField(chat.FieldCreatedAt, field.TypeTime, value)
	}
	if value, ok := cuo.mutation.UpdatedAt(); ok {
		_spec.SetField(chat.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := cuo.mutation.DeletedAt(); ok {
		_spec.SetField(chat.FieldDeletedAt, field.TypeTime, value)
	}
	if cuo.mutation.DeletedAtCleared() {
		_spec.ClearField(chat.FieldDeletedAt, field.TypeTime)
	}
	if cuo.mutation.ProfileCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ProfileTable,
			Columns: []string{chat.ProfileColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cuo.mutation.ProfileIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ProfileTable,
			Columns: []string{chat.ProfileColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if cuo.mutation.ChatRoomCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ChatRoomTable,
			Columns: []string{chat.ChatRoomColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cuo.mutation.ChatRoomIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ChatRoomTable,
			Columns: []string{chat.ChatRoomColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if cuo.mutation.ReplyToEdgeCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ReplyToEdgeTable,
			Columns: []string{chat.ReplyToEdgeColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cuo.mutation.ReplyToEdgeIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ReplyToEdgeTable,
			Columns: []string{chat.ReplyToEdgeColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if cuo.mutation.RepliesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chat.RepliesTable,
			Columns: []string{chat.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cuo.mutation.RemovedRepliesIDs(); len(nodes) > 0 && !cuo.mutation.RepliesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chat.RepliesTable,
			Columns: []string{chat.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cuo.mutation.RepliesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chat.RepliesTable,
			Columns: []string{chat.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_node = &Chat{config: cuo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, cuo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{chat.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	cuo.mutation.done = true
	return _node, nil
}
